require 'rails/generators'

module Rbacfull
  class InstallGenerator < ::Rails::Generators::Base
  	include Rails::Generators::Migration


    desc "This generator installs rbacfull files to your rails project"
  	source_root File.expand_path('../../templates', __FILE__)

    def install
      puts "Install gem's files"

    end

    def copy_migrations
      copy_migration "create_user_roles"
      copy_migration "create_roles"
      copy_migration "create_actions"
  		copy_migration "create_permissions"
    end	

    def copy_models
      copy_model "role"
      copy_model "action"
      copy_model "permission"
      copy_model "user_role"
    end


    def copy_helpers
      copy_helper "user_helper"

    end



    protected
	  def copy_migration(filename)
	    if self.class.migration_exists?("db/migrate", "#{filename}")
	      say_status("skipped", "Migration #{filename}.rb already exists")
	    else
	      migration_template "migrations/#{filename}.rb", "db/migrate/#{filename}.rb"
	    end
	  end

    def copy_model(filename)
      if self.class.migration_exists?("app/models", "#{filename}")
        say_status("skipped", "Model #{filename}.rb already exists")
      else
        copy_file "models/#{filename}.rb", "app/models/#{filename}.rb"
      end
    end

    def copy_helper(filename)
      if self.class.migration_exists?("app/helpers", "#{filename}")
        say_status("skipped", "Helper #{filename}.rb already exists")
      else
        copy_file "helpers/#{filename}.rb", "app/helpers/#{filename}.rb"
      end
    end

    def self.next_migration_number(dir)
      Time.now.utc.strftime("%Y%m%d%H%M%S%L")
    end
  end
end